import React, { useState } from 'react';
import { Icon } from '../Icon';
import { DropMenuItemButton, DropMenuItemContainer, DropMenuItemTitle, DropMenuList, DropMenuOpenButton, TinyDropMenuWrapper, } from './styles';
import { DropDirection } from './constants';
import { TinyDropMenuContext, useTinyDropMenuContext, } from './TinyDropMenuContext';
export var TinyDropMenu = function (_a) {
    var children = _a.children, closeOnItemClick = _a.closeOnItemClick, _b = _a.color, color = _b === void 0 ? 'primary' : _b, _c = _a.dropDirection, dropDirection = _c === void 0 ? DropDirection.UP : _c;
    var _d = useState(false), open = _d[0], setOpen = _d[1];
    var _e = useState(false), closeAnimate = _e[0], setCloseAnimate = _e[1];
    var closeMenu = function () {
        setCloseAnimate(true);
        setTimeout(function () {
            setOpen(false);
            setCloseAnimate(false);
        }, 200);
    };
    return (React.createElement(TinyDropMenuWrapper, null,
        React.createElement(TinyDropMenuContext.Provider, { value: {
                color: color,
                dropDirection: dropDirection,
                closeMenu: closeOnItemClick ? closeMenu : undefined,
            } },
            React.createElement(DropMenuOpenButton, { color: color, open: open && !closeAnimate, onClick: open ? closeMenu : function () { return setOpen(true); }, dropDirection: dropDirection },
                React.createElement(Icon, { name: "ellipsis", size: "large", fitted: true, color: "white" })),
            open && (React.createElement(DropMenuList, { dropDirection: dropDirection, closeAnimate: closeAnimate }, children)))));
};
export var TinyDropMenuItem = function (_a) {
    var onClick = _a.onClick, disabled = _a.disabled, renderIcon = _a.renderIcon, renderTitle = _a.renderTitle;
    var _b = useTinyDropMenuContext(), color = _b.color, closeMenu = _b.closeMenu, dropDirection = _b.dropDirection;
    var onItemClick = function () {
        onClick();
        if (closeMenu) {
            closeMenu();
        }
    };
    return (React.createElement(DropMenuItemButton, { dropDirection: dropDirection, color: color, onClick: onItemClick, disabled: disabled },
        renderIcon(),
        React.createElement(DropMenuItemContainer, { color: color },
            React.createElement(DropMenuItemTitle, null, renderTitle()))));
};
