var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState } from 'react';
import { Icon } from "../../elements";
import { DropdownHeader, DropdownHeaderArrowWrapper, DropdownHeaderTitle, DropdownItem, DropdownItemWrapper, DropdownWrapper, } from './styles';
export var Dropdown = function (_a) {
    var onClick = _a.onClick, children = _a.children, className = _a.className, selected = _a.selected, options = _a.options, renderItem = _a.renderItem;
    var _b = useState(false), open = _b[0], setOpen = _b[1];
    var handleHeaderClick = function () { return setOpen(function (prevOpen) { return !prevOpen; }); };
    var dropdownOptions = options.map(function (props) {
        var _a = props, label = _a.label, render = _a.render, value = _a.value, rest = __rest(_a, ["label", "render", "value"]);
        var handleClick = function (e) {
            onClick === null || onClick === void 0 ? void 0 : onClick(e, props);
            setOpen(false);
        };
        var active = label === selected;
        var contents;
        if (render) {
            contents = render(props);
        }
        else if (renderItem) {
            contents = renderItem(props);
        }
        else {
            contents = React.createElement("span", null, label);
        }
        return (React.createElement(DropdownItem, __assign({ key: label, active: active, onClick: handleClick }, rest), contents));
    });
    var header = children ? (React.createElement("div", { onClick: handleHeaderClick }, children)) : (React.createElement(DropdownHeader, { onClick: handleHeaderClick, isOpen: open },
        React.createElement(DropdownHeaderTitle, null, selected),
        React.createElement(DropdownHeaderArrowWrapper, null,
            React.createElement(Icon, { name: "caret-down", size: "medium" }))));
    return (React.createElement(DropdownWrapper, { className: className },
        header,
        open && React.createElement(DropdownItemWrapper, null, dropdownOptions)));
};
