import React, { useMemo, useCallback, useState, useEffect, useRef, } from 'react';
import cx from 'clsx';
import { Icon } from "../../elements";
import { SelectWrapper, SelectDropdown, SelectDiv } from './styles';
export var Select = function (_a) {
    var options = _a.options, placeholder = _a.placeholder, value = _a.value, onChange = _a.onChange, onClear = _a.onClear, fluid = _a.fluid, basic = _a.basic, className = _a.className, text = _a.text, color = _a.color, dropup = _a.dropup;
    var ref = useRef(null);
    var dropdown = useRef(null);
    var _b = useState(false), active = _b[0], setActive = _b[1];
    var selection = useMemo(function () {
        if (text) {
            return React.createElement("span", { className: "text" }, text);
        }
        if (value && options) {
            var item = options.find(function (o) { return o.value === value; });
            return React.createElement("span", null, item === null || item === void 0 ? void 0 : item.text);
        }
        return React.createElement("span", { className: "placeholder" }, placeholder);
    }, [options, placeholder, text, value]);
    var handleClear = useCallback(function (e) {
        onClear === null || onClear === void 0 ? void 0 : onClear();
        e.stopPropagation();
    }, [onClear]);
    var handleClick = useCallback(function () {
        setActive(!active);
    }, [active]);
    var handleClickOut = useCallback(function (e) {
        var _a;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) {
            return;
        }
        setActive(false);
    }, []);
    var stateClassName = cx({
        active: active,
        basic: basic,
    });
    var contents = useMemo(function () { return options === null || options === void 0 ? void 0 : options.map(function (o) { return (React.createElement("div", { key: o.key, className: cx('option', {
            selected: o.key === value,
        }), onClick: function (e) {
            onChange === null || onChange === void 0 ? void 0 : onChange(e, o);
            setActive(false);
        } }, o.text)); }); }, [onChange, options, value]);
    var showClear = useMemo(function () { return value && onClear; }, [onClear, value]);
    // Close on click outside
    useEffect(function () {
        document.addEventListener('mousedown', handleClickOut, false);
        return function () {
            return document.removeEventListener('mousedown', handleClickOut, false);
        };
    }, [handleClickOut]);
    return (React.createElement(SelectWrapper, { ref: ref, fluid: fluid, basic: basic },
        React.createElement(SelectDiv, { className: stateClassName, onClick: handleClick },
            selection,
            React.createElement(Icon, { name: showClear ? 'times' : 'caret-down', onClick: showClear ? handleClear : undefined, fitted: true })),
        active && (React.createElement(SelectDropdown, { ref: dropdown, dropup: dropup, color: color }, contents))));
};
